package com.engine.organization.service;

import com.engine.organization.entity.scheme.param.GradeSearchParam;
import com.engine.organization.util.MenuBtn;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @description:
 * @author:dxfeng
 * @createTime: 2022/05/11
 * @version: 1.0
 */
public interface GradeService {
    /**
     * 职级列表
     *
     * @param params
     * @return
     */
    Map<String, Object> listPage(Map<String, Object> params);

    /**
     * 新增职级
     * @param param
     * @return
     */
    int saveGrade(GradeSearchParam param);

    /**
     * 更新职级信息
     *
     * @param param
     * @return
     */
    int updateGrade(GradeSearchParam param);

    /**
     * 更新禁用标记
     *
     * @param params
     */
    int updateForbiddenTagById(GradeSearchParam params);

    /**
     * 根据ID批量删除
     *
     * @param ids
     */
    int deleteByIds(Collection<Long> ids);

    /**
     * 获取搜索条件
     *
     * @param params
     * @return
     */
    Map<String, Object> getSearchCondition(Map<String, Object> params);


    /**
     * 获取新增表单
     *
     * @param params
     * @return
     */
    Map<String, Object> getGradeForm(Map<String, Object> params);

    /**
     * 获取列表页面按钮信息
     * @return
     */
    Map<String, List<MenuBtn>> getHasRight();

    /**
     * 获取列表tabs
     * @return
     */
    Map<String, Object> getTabInfo();


    String getLevelId(Long id);
}
